%global eclipse_dropin   %{_datadir}/eclipse/dropins

Name:      eclipse-dltk
Version:   5.1.0
Release:   2%{?dist}
Summary:   Dynamic Languages Toolkit (DLTK) Eclipse plug-in
License:   EPL
URL:       http://www.eclipse.org/dltk/

# source tarball and the script used to generate it from upstream's source control
# script usage:
# $ sh get-dltk.sh
Source0:   %{name}-%{version}.tar.xz
Source1:   get-dltk.sh

Patch0: drop_from_p2.patch

BuildArch:        noarch

BuildRequires:    eclipse-license >= 1.0.1
BuildRequires:    eclipse-pde >= 1:4.4.0
BuildRequires:    eclipse-emf
BuildRequires:    eclipse-mylyn
BuildRequires:    eclipse-mylyn-ide
BuildRequires:    eclipse-rse
BuildRequires:    h2
BuildRequires:    maven-local
BuildRequires:    tycho
Requires:         eclipse-platform >= 1:4.4.0
Requires:         eclipse-emf
Requires:         h2

%description
Dynamic Languages Toolkit (DLTK) is a tool for vendors, researchers, and users
who rely on dynamic languages. DLTK is comprised of a set of extensible
frameworks designed to reduce the complexity of building full featured
development environments for dynamic languages such as PHP and Perl.

%package   ruby
Summary:   Ruby Eclipse plug-in
Requires:  %{name} = %{version}-%{release}

%description ruby
Ruby development environment for Eclipse based on the Eclipse Dynamic
Languages Toolkit (DLTK).

%package   tcl
Summary:   TCL Eclipse plug-in
Requires:  %{name} = %{version}-%{release}
Requires:  eclipse-emf >= 2.5.0

%description tcl
TCL development environment for Eclipse based on the Eclipse Dynamic
Languages Toolkit (DLTK).

%package   itcl
Summary:   Incr TCL extension for the TCL Eclipse plug-in
Requires:  %{name}-tcl = %{version}-%{release}

%description itcl
Incr TCL extension for the TCL Eclipse plug-in.

%package   xotcl
Summary:   XOTCL extension for the TCL Eclipse plug-in
Requires:  %{name}-tcl = %{version}-%{release}

%description xotcl
XOTCL extension for the TCL Eclipse plug-in.

#%%package   javascript
#Summary:   Javascript Eclipse plug-in
#Requires:  %%{name} = %%{version}-%%{release}

#%%description javascript
#Javascript development environment for Eclipse based on the Eclipse
#Dynamic Languages Toolkit (DLTK).

%package   mylyn
Summary:   Mylyn integration for Eclipse DLTK projects
Requires:  %{name} = %{version}-%{release}
Requires:  eclipse-mylyn
Requires:  eclipse-mylyn-ide

%description mylyn
Mylyn task-focused UI integration for Eclipse Dynamic Languages Toolkit
(DLTK) projects.

%package   rse
Summary:   RSE integration for Eclipse DLTK projects
Requires:  %{name} = %{version}-%{release}
Requires:  eclipse-rse

%description rse
Remote Development Support via RSE for DLTK based IDEs.

%package   sdk
Summary:   Eclipse DLTK SDK
Requires:  eclipse-pde >= 1:4.4.0
Requires:  %{name}       = %{version}-%{release}
Requires:  %{name}-ruby  = %{version}-%{release}
Requires:  %{name}-tcl   = %{version}-%{release}
Requires:  %{name}-itcl  = %{version}-%{release}
Requires:  %{name}-xotcl = %{version}-%{release}
#Requires:  %%{name}-javascript = %%{version}-%%{release}
Requires:  %{name}-mylyn = %{version}-%{release}
Requires:  %{name}-rse   = %{version}-%{release}

%description sdk
Documentation and source for the Eclipse Dynamic Languages Toolkit (DLTK).

# TODO: Uncomment the Javascript package bits when upstream gets their Rhino dependencies sanely externalised

%prep
%setup -q  

%pom_disable_module "../../org.eclipse.dltk.javascript" org.eclipse.dltk.releng/build/pom.xml
%pom_disable_module "../../org.eclipse.dltk.python" org.eclipse.dltk.releng/build/pom.xml

%pom_disable_module "releng/org.eclipse.dltk.core.targetplatform" org.eclipse.dltk.core/core/pom.xml
%pom_disable_module "features/org.eclipse.dltk.core.tests" org.eclipse.dltk.core/core/pom.xml
%pom_disable_module "tests" org.eclipse.dltk.core/core/pom.xml
%pom_disable_module "tests" org.eclipse.dltk.tcl/tcl/pom.xml
%pom_disable_module "tests/org.eclipse.dltk.itcl.core.tests" org.eclipse.dltk.tcl/itcl/pom.xml
%pom_disable_module "tests/org.eclipse.dltk.xotcl.core.tests" org.eclipse.dltk.tcl/xotcl/pom.xml
%pom_disable_module "tests/org.eclipse.dltk.ruby.core.tests" org.eclipse.dltk.ruby/pom.xml
%pom_disable_module "tests/org.eclipse.dltk.ruby.formatter.tests" org.eclipse.dltk.ruby/pom.xml
%pom_disable_module "tests/org.eclipse.dltk.ruby.ui.tests" org.eclipse.dltk.ruby/pom.xml
%pom_disable_module "tests/org.eclipse.dltk.ruby.testing.tests" org.eclipse.dltk.ruby/pom.xml

%patch0

# This should not be necessary in the future
mkdir -p .m2/p2/repo-sdk/features/
cp -r %{_javadir}/eclipse-license/eclipse/features/* .m2/p2/repo-sdk/features/

%build
xmvn -o clean verify -forg.eclipse.dltk.releng/build/pom.xml

%install
install -d -m 755 %{buildroot}%{eclipse_dropin}

SUBPACKAGES="core.index core ruby tcl itcl xotcl mylyn rse"

mkdir -p %{buildroot}%{eclipse_dropin}/dltk-sdk/eclipse/plugins
mkdir -p %{buildroot}%{eclipse_dropin}/dltk-sdk/eclipse/features

pushd org.eclipse.dltk.releng/build/update.site/target/site
mv plugins/org.eclipse.dltk.*.source* %{buildroot}%{eclipse_dropin}/dltk-sdk/eclipse/plugins
mv features/org.eclipse.dltk.*.sdk* %{buildroot}%{eclipse_dropin}/dltk-sdk/eclipse/features

for s in $SUBPACKAGES ; do

  mkdir -p %{buildroot}%{eclipse_dropin}/dltk-$s/eclipse/plugins
  mkdir -p %{buildroot}%{eclipse_dropin}/dltk-$s/eclipse/features

  mv plugins/org.eclipse.dltk.$s* %{buildroot}%{eclipse_dropin}/dltk-$s/eclipse/plugins
  mv features/org.eclipse.dltk.$s* %{buildroot}%{eclipse_dropin}/dltk-$s/eclipse/features
done

#Install .launching, .debug*, .ui, .console bundles into core
mv plugins/org.eclipse.dltk_* %{buildroot}%{eclipse_dropin}/dltk-core/eclipse/plugins
mv plugins/org.eclipse.dltk.annotations* %{buildroot}%{eclipse_dropin}/dltk-core/eclipse/plugins
mv plugins/org.eclipse.dltk.console* %{buildroot}%{eclipse_dropin}/dltk-core/eclipse/plugins
mv plugins/org.eclipse.dltk.debug* %{buildroot}%{eclipse_dropin}/dltk-core/eclipse/plugins
mv plugins/org.eclipse.dltk.formatter* %{buildroot}%{eclipse_dropin}/dltk-core/eclipse/plugins
mv plugins/org.eclipse.dltk.launching* %{buildroot}%{eclipse_dropin}/dltk-core/eclipse/plugins
mv plugins/org.eclipse.dltk.logconsole* %{buildroot}%{eclipse_dropin}/dltk-core/eclipse/plugins
mv plugins/org.eclipse.dltk.testing* %{buildroot}%{eclipse_dropin}/dltk-core/eclipse/plugins
mv plugins/org.eclipse.dltk.ui* %{buildroot}%{eclipse_dropin}/dltk-core/eclipse/plugins
mv plugins/org.eclipse.dltk.validators* %{buildroot}%{eclipse_dropin}/dltk-core/eclipse/plugins

#install org.eclipse.dltk.ssh.core to rse
mv plugins/org.eclipse.dltk.ssh.core* %{buildroot}%{eclipse_dropin}/dltk-rse/eclipse/plugins

# Install symlinks to required OSGi jars
ln -s %{_javadir}/h2.jar %{buildroot}/%{eclipse_dropin}/dltk-core.index/eclipse/plugins/org.h2.jar

popd

# Unzip features -- temporary measure until xmvn lands
pushd %{buildroot}%{eclipse_dropin}
for f in $( ls dltk*/eclipse/features/* ) ; do
  dirname=${f%.jar}
  mkdir -p $dirname
  unzip $f -d $dirname
  rm $f
done
popd

%files
%{eclipse_dropin}/dltk-core
%{eclipse_dropin}/dltk-core.index
%doc org.eclipse.dltk.core/core/features/org.eclipse.dltk.core-feature/rootfiles/*

%files ruby
%{eclipse_dropin}/dltk-ruby
%doc org.eclipse.dltk.ruby/features/org.eclipse.dltk.ruby-feature/rootfiles/*

%files tcl
%{eclipse_dropin}/dltk-tcl
%doc org.eclipse.dltk.tcl/tcl/features/org.eclipse.dltk.tcl-feature/rootfiles/*

%files itcl
%{eclipse_dropin}/dltk-itcl
%doc org.eclipse.dltk.tcl/itcl/features/org.eclipse.dltk.itcl-feature/rootfiles/*

%files xotcl
%{eclipse_dropin}/dltk-xotcl
%doc org.eclipse.dltk.tcl/xotcl/features/org.eclipse.dltk.xotcl-feature/rootfiles/*

#%files javascript
#%{eclipse_dropin}/dltk-javascript
#%doc org.eclipse.dltk.javascript-feature/rootfiles/*

%files mylyn
%{eclipse_dropin}/dltk-mylyn
%doc org.eclipse.dltk.core/mylyn/features/org.eclipse.dltk.mylyn-feature/rootfiles/*

%files rse
%{eclipse_dropin}/dltk-rse
%doc org.eclipse.dltk.core/rse/features/org.eclipse.dltk.rse-feature/rootfiles/*

%files sdk
%{eclipse_dropin}/dltk-sdk
%doc org.eclipse.dltk.core/core/features/org.eclipse.dltk.core.sdk/rootfiles/*

%changelog
* Thu Sep 04 2014 Mat Booth <mat.booth@redhat.com> - 5.1.0-2
- Unzip feature bundles on installation

* Thu Jun 26 2014 Mat Booth <mat.booth@redhat.com> - 5.1.0-1
- Update to latest upstream release

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.1.0-0.2.git9eca4e
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri May 09 2014 Mat Booth <mat.booth@redhat.com> - 5.1.0-0.1.git9eca4e
- Update to latest upstream for Luna compatibility.
- Add BR on eclipse-license
- Drop unnecessary BR/Rs
- Build with xmvn
- Fix bogus dates

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 5.0.0-4
- Use Requires: java-headless rebuild (#1067528)

* Mon Aug 5 2013 Krzysztof Daniel <kdaniel@redhat.com> 5.0.0-3
- Fix FTBFS.

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Jul 5 2013 Alexander Kurtakov <akurtako@redhat.com> 5.0.0-1
- Update to upstream Kepler release 5.0.0.

* Thu Feb 21 2013 Alexander Kurtakov <akurtako@redhat.com> 4.0.0-5
- Let tycho skip its version checks.

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.0.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 4.0.0-3
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Jul 16 2012 Sami Wagiaalla <swagiaal@redhat.com> - 4.0.0-1
- Update to 4.0.0 release.

* Thu Jun 14 2012 Roland Grunberg <rgrunber@redhat.com> - 4.0.0-0.5.201201070225cvs
- Remove patches that bump BREE to JavaSE-1.6 (done by Tycho).
- Remove patch and %%prep lines that create p2 repository (done by Tycho).

* Thu May 03 2012 Sami Wagiaalla <swagiaal@redhat.com> - 4.0.0-0.4.201201070225cvs
- Install a symlink to h2 in dropins.
- Remove blanket symlink of javadir.

* Wed Apr 25 2012 Sami Wagiaalla <swagiaal@redhat.com> - 4.0.0-0.3.201201070225cvs
- Install missing bundles.

* Tue Apr 24 2012 Sami Wagiaalla <swagiaal@redhat.com> - 4.0.0-0.2.201201070225cvs
- Checkout entire org.eclipse.dltk module.
- Patch dltk to build with tycho 0.14.0
- Use tycho to build dltk
- Add tycho and maven requirements.

* Thu Apr 12 2012 Sami Wagiaalla <swagiaal@redhat.com> - 4.0.0-0.1.201201070225cvs
- Update to upstream 4.0.0 snapshot.

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Fri Dec 16 2011 Alexander Kurtakov <akurtako@redhat.com> 3.0.1-1
- Update to upstream 3.0.1.

* Tue Jul 12 2011 Alexander Kurtakov <akurtako@redhat.com> 3.0-2
- Add more mylyn subpackages to BR/R.

* Tue Jul 12 2011 Alexander Kurtakov <akurtako@redhat.com> 3.0-1
- Update to upstream 3.0.

* Tue Jul 5 2011 Andrew Overholt <overholt@redhat.com> 2.0.1-4
- Update dropins locations to reflect Mylyn split.

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Dec 6 2010 Alexander Kurtakov <akurtako@redhat.com> 2.0.1-2
- BR/R h2 and fix build.

* Tue Oct 19 2010 Chris Aniszczyk <zx@redhat.com> 2.0.1-1
- Update to 2.0.1.

* Sun Jul 18 2010 Alexander Kurtakov <akurtako@redhat.com> 2.0.0-1
- Update to 2.0.0.

* Wed Mar 03 2010 Mat Booth <fedora@matbooth.co.uk> 1.0.2-1
- Update to 1.0.2

* Wed Jan 20 2010 Alexander Kurtakov <akurtako@redhat.com> 1.0.0-4
- Main package should require emf.

* Thu Aug 20 2009 Mat Booth <fedora@matbooth.co.uk> 1.0.0-3
- Add a SDK package.
- Require Mylyn >= 3.2.

* Mon Aug 10 2009 Alexander Kurtakov <akurtako@redhat.com> 1.0.0-2
- Add RSE plugin.

* Mon Aug 10 2009 Alexander Kurtakov <akurtako@redhat.com> 1.0.0-1
- Update to 1.0.0 final.

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.0-0.6.RC1b
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri May 22 2009 Alexander Kurtakov <akurtako@redhat.com> 1.0.0-0.5.RC1b
- Update to 1.0.0 RC1b.
- Use %%global instead of %%define.

* Sat Apr 18 2009 Mat Booth <fedora@matbooth.co.uk> 1.0.0-0.4.M6
- Update to Milestone 6 release of 1.0.0.
- Require Eclipse 3.5.0.

* Thu Apr 02 2009 Mat Booth <fedora@matbooth.co.uk> 1.0.0-0.3.M5
- Fix files listed twice warnings.

* Thu Apr 02 2009 Mat Booth <fedora@matbooth.co.uk> 1.0.0-0.2.M5
- Drop GCJ AOT support.

* Mon Mar 30 2009 Mat Booth <fedora@matbooth.co.uk> 1.0.0-0.1.M5
- Initial release.
